<svelte:window on:touchstart|passive="handleGestureStart(event)"
               on:touchmove|passive="handleGestureMove(event, initialTouchPos, rafPending)"
               on:touchend|passive="handleGestureEnd(event)"
               on:touchcancel|passive="handleGestureEnd(event)"

               on:mousedown|passive="handleGestureStart(event)"

               on:mousemove|passive="handleGestureMove(event, initialTouchPos, rafPending, !dragging)"
               on:mouseup|passive="handleGestureEnd(event, !dragging)" />

<div ref:drawer
     class="drawer"
     class:left="position=='left'"
     class:right="position=='right'">
  <slot/>
</div>

<script>
  import device from "../js/device";

  function cssize(screenPixels) {
    return screenPixels / devicePixelRatio;
  }
  
  function getGesturePointFromEvent(evt) {
    const point = {};
    if (evt.targetTouches) {
      point.x = evt.targetTouches[0].clientX / devicePixelRatio;
      point.y = evt.targetTouches[0].clientY / devicePixelRatio;
    } else {
      // Either Mouse event or Pointer Event
      point.x = cssize(evt.clientX);
      point.y = cssize(evt.clientY);
    }
    return point;
  }
  
  export default {
    data() {
      return {
        currentXPosition: 0
      };
    },
    methods: {
      drawerSafe() {
        return device.isMobileView();
      },
      handleGestureEnd(evt, breakdown) {
        if (breakdown || !this.drawerSafe()) return;
        // evt.preventDefault();
        if (evt.touches && evt.touches.length > 0) return;
        this.set({rafPending: false, dragging: false});
        this.updateSwipeRestPosition();
        this.set({initialTouchPos: null});
      },
      updateSwipeRestPosition() {
        if (!this.drawerSafe()) return;
        const got = this.get();
        if (!got.lastTouchPos || !got.initialTouchPos) return;
        this.refs.drawer.style.transition = "";
        const diff =
          got.position == "left"
            ? got.lastTouchPos.x - got.initialTouchPos.x
            : got.initialTouchPos.x - got.lastTouchPos.x;
        let open = got.open;
        if (Math.abs(diff) > cssize(this.refs.drawer.clientWidth) / 3) {
          if (diff > 0) {
            open = true;
          } else {
            open = false;
          }
        }
        if (open) {
          const pos = cssize(device.lastWidth) * 0.7;
          this.set({
            openedAmount: pos,
            currentXPosition: pos,
            open: true
          });
          this.refs.drawer.style.transform = `translateX(${
            got.position == "right" ? "-70vw" : "70vw"
          })`;
        } else {
          this.set({openedAmount: 0, currentXPosition: 0, open: false});
          this.refs.drawer.style.transform = "";
        }
      },
      handleGestureStart(evt) {
        if (!this.drawerSafe()) return;
        // evt.preventDefault();
        if (evt.touches && evt.touches.length > 1) return;
        const points = getGesturePointFromEvent(evt);
        const got = this.get();
        const gap = Math.abs(
          got.position == "left" ? points.x : cssize(device.lastWidth) - points.x
        );
        if (!got.open && gap > 20) return;
        else if (got.open && cssize(this.refs.drawer.clientWidth) - gap > 20)
          return;
        this.set({
          dragging: true,
          initialTouchPos: points
        });
        this.refs.drawer.style.transition = "initial";
      },
      handleGestureMove(evt, initialTouchPos, rafPending, breakdown) {
        if (!this.drawerSafe()) return;
        if (breakdown) return;
        // evt.preventDefault();
        if (!initialTouchPos) return;

        this.set({
          lastTouchPos: getGesturePointFromEvent(evt),
          rafPending: true
        });
        if (rafPending) return;
        window.requestAnimationFrame(this.animationFrame.bind(this));
      },
      animationFrame() {
        if (!this.drawerSafe()) return;
        const got = this.get();
        if (!got.rafPending) return;
        let newXTransform =
          got.position == "left"
            ? devicePixelRatio * got.lastTouchPos.x + "px"
            : `calc(-1 * (100vw - ${got.lastTouchPos.x * devicePixelRatio}px))`;
        let openedAmount =
          got.position == "left"
            ? got.lastTouchPos.x
            : cssize(device.lastWidth) - got.lastTouchPos.x;

        if (
          got.position == "left" &&
          got.lastTouchPos.x > cssize(device.lastWidth) * 0.7
        ) {
          newXTransform = "70vw";
          openedAmount = cssize(device.lastWidth) * 0.7;
        } else if (
          got.position == "right" &&
          got.lastTouchPos.x < cssize(device.lastWidth) * 0.3
        ) {
          newXTransform = "-70vw";
          openedAmount = cssize(device.lastWidth) * 0.7;
        }

        // (got.currentXPosition - differenceInX) + "px";
        const transformStyle = `translateX(${newXTransform})`;
        this.refs.drawer.style.transform = transformStyle;
        console.log("openedAmount", openedAmount);
        console.log(
          "y",
          `background:rgba(0, 0, 0, ${Math.floor(
            (openedAmount / cssize(device.lastWidth * 0.7)) * 100
          )})`
        );
        this.set({
          rafPending: false,
          openedAmount
        });
      }
    },
    onstate({current, changed}) {
      if (changed.openedAmount) {
        this.store.set({
          shade: Math.abs(current.openedAmount) / cssize(device.lastWidth * 0.7)
        });
      }
    }
  };
</script>

<style>
  .drawer {
    display: flex;
  }

  @media (max-width: 700px) {
    .drawer {
      background: #101112;
      height: 100vh;
      z-index: 50;
      width: 70vw;
      transition-property: transform;
      transition-duration: 150ms;
      transition-timing-function: ease-out;
    }
    .drawer.left {
      transform: translateX(0);
    }
    .drawer.right {
      transform: translateX(70vw);
    }
  }
</style>
